cat("AlloppSim started\n")
Args <- commandArgs(TRUE)
stopifnot(length(Args) == 2)
computer <- Args[1]
stopifnot(Args[1] == "VOSTROWIN7" || Args[1] == "DELLVISTA" || 
          Args[1] == "NETBOOKWIN7" || Args[1] == "NETBOOKUBUNTU" ||
          Args[1] == "CLUSTER")
config.dir <- Args[2]
# input config is here. All output goes in subdirectories of this


# where this code is
if (computer=="VOSTROWIN7") {
  setwd("C:/Users/Graham/AAA/Programming/Goteborg/AlloppRcode")
  } else if  (computer=="DELLVISTA") {
  setwd("C:/AAA/Programming/Goteborg/AlloppRcode")
  } else if  (computer=="NETBOOKWIN7") {
  setwd("C:/AAA/Programming/Goteborg/simulation_di_tets_multigene")
  } else if  (computer=="NETBOOKUBUNTU") {
  setwd("/home/graham/simulation_di_tets_multigene")
  } else if  (computer=="CLUSTER") {
  setwd("/home/gjones/simulation_di_tets_multigene")
  }



# java classpath for calling BEAST
if (computer=="VOSTROWIN7") {
  java.classpath <- ".;C:\\Users\\Graham\\AAA\\Programming\\Goteborg\\workspace\\beast17\\1.7\\bin;C:\\Users\\Graham\\AAA\\Programming\\Goteborg\\workspace\\beast17\\1.7\\lib\\*"
  } else if  (computer=="DELLVISTA") {
  java.classpath <- ".;C:\\AAA\\Programming\\Goteborg\\workspace\\beast16\\bin;C:\\AAA\\Programming\\Goteborg\\workspace\\beast16\\lib\\*"
  } else if  (computer=="NETBOOKWIN7") {
  java.classpath <- ".;C:\\AAA\\Programming\\Goteborg\\workspace\\beast16\\bin;C:\\AAA\\Programming\\Goteborg\\workspace\\beast16\\lib\\*"
  } else if  (computer=="NETBOOKUBUNTU") {
  java.classpath <- "'.:/home/graham/Programming/workspace/beast16/bin/:/home/graham/Programming/workspace/beast16/lib/*'" 
  } else if  (computer=="CLUSTER") {
  java.classpath <- "'.:/home/gjones/beast16/build/:/home/gjones/beast16/lib/*'"
  }   

               
# for calling Seq-Gen             
if (computer=="VOSTROWIN7") {
  seqgenbasecmd <- "seqgen.exe -mHKY -t3.0 -f0.3,0.2,0.2,0.3"
  } else if  (computer=="DELLVISTA") {
  seqgenbasecmd <- "seqgen.exe -mHKY -t3.0 -f0.3,0.2,0.2,0.3"
  } else if  (computer=="NETBOOKWIN7") {
  seqgenbasecmd <- "seqgen.exe -mHKY -t3.0 -f0.3,0.2,0.2,0.3"
  } else if  (computer=="NETBOOKUBUNTU") {
  seqgenbasecmd <- "$PWD/seqgen -mHKY -t3.0 -f0.3,0.2,0.2,0.3" 
  } else if  (computer=="CLUSTER") {
  seqgenbasecmd <- "$PWD/seqgen -mHKY -t3.0 -f0.3,0.2,0.2,0.3"
  }
  



library(ape)

source("AlloppSim_0randomseeds.r")

source("AlloppSim_1readconfig2.r")
source("AlloppSim_2makemultree.r")
source("AlloppSim_3makegtrees.r")
source("AlloppSim_4makeseqfiles.r")
source("AlloppSim_5beastxml_toplevel.r")
source("AlloppSim_6beastxml_bits.r")





make.beastxml.for.one.GNT.one.replicate <- function(config, i, r, mulTreeVersion) {  
  # Simulate the gene trees
  for (g in 1:config$configG[i]) {
    gt <- make.one.genetree.as.Newick(multree, config$configT[i], randomseeds[g, r])
    sink(fpath.gtree(config, i, r, g))
    cat(gt)
    sink(NULL)
    }
  
  # Simulate the sequence alignments
  for (g in 1:config$configG[i]) {  
    SeqGen.cmd <- paste(seqgenbasecmd, 
                        " -l", config$seqs$len, 
                        " -n1 -z", randomseeds[g, r], 
                        " ", fpath.gtree(config, i, r, g), 
                        " -y ", fpath.seq(config, i, r, g), 
                        sep="")
    cat("Running seqgen with command:", SeqGen.cmd, "\n")
    system(SeqGen.cmd)
    }
    
  
  # Make BEAST XML
  sink(fpath.beastxml(config, i, r))
  make.beastxml.from.sim.network(config$network, config$configG[i],
                collect.taxa(multree), 
                fpath.seqs.fpathbase(config, i, r), 
                fpath.sampledgtrees.fpathbase(config, i, r),
                fpath.sampledmultrees(config, i, r), 
                fpath.sampledparams(config, i, r), 
                fpath.DBUGTUNE(config, i, r),
                mulTreeVersion
                )
  sink(NULL)
  
}


  

run.beast.for.one.GNT.one.replicate <- function(config, i, r) {
  BEAST.cmd <- paste("java -classpath", java.classpath, 
          "dr.app.beast.BeastMain -seed", beast.randomseed, "-overwrite -working", 
          fpath.beastxml(config, i, r))
  system(BEAST.cmd)
  }  
  

run.treeannotator.for.one.GNT.one.replicate <- function(config, i, r) {
  for (g in 1:config$configG[i]) {
    TreeAnnotator.cmd <-paste("java -classpath", java.classpath, 
          "dr.app.tools.TreeAnnotator -burnin", treeann.burnin, 
          fpath.sampledgtree(config, i, r, g),
          fpath.mccgtree(config, i, r, g)
          )
    system(TreeAnnotator.cmd)
    }
  TreeAnnotator.cmd <-paste("java -classpath", java.classpath, 
          "dr.app.tools.TreeAnnotator -burnin", treeann.burnin,
          fpath.sampledmultrees(config, i, r),
          fpath.mccmultree(config, i, r)
          )      
   system(TreeAnnotator.cmd)
  }
  
  
simplify.mcc.for.one.GNT.one.replicate <- function(config, i, r, simmul1, simmul2) {
  for (g in 1:config$configG[i]) {
    mccmul <- read.nexus(file=fpath.mccgtree(config, i, r, g))
    #cat(scenario.name, "G =", config$configG[i], "N =", config$configN[i], 
    #       "T =", config$configT[i], "replicate", r, "gene tree", g, "\n")
    #cat(write.tree(mccmul), "\n")
    }
  
  mccmul <- read.nexus(file=fpath.mccmultree(config, i, r))
  sametopol <- all.equal(simmul1, mccmul, use.edge.length = FALSE)
  sametopol <- sametopol  ||  all.equal(simmul2, mccmul, use.edge.length = FALSE)
  cat(all.files.prefix , "G =", config$configG[i], "N =", config$configN[i], 
         "T =", config$configT[i], "replicate", r, "MUL-tree", sametopol, "\n")
  cat(write.tree(mccmul), "\n")
  }
 
 
mccmultree.is.simmultree <- function(config, i, r, simmul1, simmul2) {
  mccmul <- read.nexus(file=fpath.mccmultree(config, i, r))
  sametopol <- all.equal(simmul1, mccmul, use.edge.length = FALSE)
  sametopol <- sametopol  ||  all.equal(simmul2, mccmul, use.edge.length = FALSE)
  sametopol
  }



####################################################################
####################################################################

 

 
analysis.info <- analysis.info.from.config.dir(config.dir)
all.files.prefix  <- analysis.info$all.files.prefix

cat("AlloppSim running with directory", config.dir, "\n")

config <- read.config2(paste(config.dir, "/", "config.txt", sep=""))

nofGNT <- length(config$configG)
beast.randomseed <- config$progparams$beastseed
beast.chain.length <- config$progparams$beastchainlength
beast.screen.logevery <- config$progparams$beastscreen.logevery
beast.params.logevery <- config$progparams$beastparams.logevery
beast.gtrees.logevery <- config$progparams$beastgtrees.logevery
beast.multree.logevery <- config$progparams$beastmultree.logevery
beast.dbugtune.logevery <- config$progparams$beastdbugtune.logevery
treeann.burnin <- config$progparams$treeannburnin





replicate.sets <- NULL
for (i in 1:nofGNT) {
  R <- config$configR[i]
  stopifnot(R <= dim(randomseeds)[2]) 
  replicate.sets <- c(replicate.sets, list(1:R))
  }

 # FIX FOR DEBUGGING   2011-12-09
# replicate.sets[[1]] <- (4:4) 
 
 
  
for (i in 1:nofGNT) {
  config$network <- fillin.indivs(config$network, config$configN[i])
  stopifnot(config$configG[i] <= dim(randomseeds)[1])
  dir.create(fpath.GNTdpath(config, i))
  
  # Make the MUL-tree
  multree <- make.multree(config$network)
  
  sink(fpath.multree(config, i))
  print.multree(multree)
  sink(NULL)
  
  for (r in replicate.sets[[i]]) {
    make.beastxml.for.one.GNT.one.replicate(config, i, r, analysis.info$mulTreeVersion)
    }
  }
  
  
for (i in 1:nofGNT) {
  config$network <- fillin.indivs(config$network, config$configN[i])
  for (r in replicate.sets[[i]]) {
    run.beast.for.one.GNT.one.replicate(config, i, r)
    }
  }
  

for (i in 1:nofGNT) {
  for (r in replicate.sets[[i]]) {
    run.treeannotator.for.one.GNT.one.replicate(config, i, r)
    }
  }
  
  
for (i in 1:nofGNT) {
  for (r in replicate.sets[[i]]) {
    simplify.mcc.for.one.GNT.one.replicate(config, i, r, analysis.info$simmul1, analysis.info$simmul2)
    }
  }



for (i in 1:nofGNT) {
  nok <- 0
  for (r in replicate.sets[[i]]) {
    if (mccmultree.is.simmultree(config, i, r, analysis.info$simmul1, analysis.info$simmul2)) {
      nok <- nok + 1
      }
    }
  cat(all.files.prefix, "G =", config$configG[i], "N =", config$configN[i], 
         "T =", config$configT[i], nok, "/", length(replicate.sets[[i]]), "\n")
  }

